// Written by TeTeT
// prototype for deploying a MAAS system

maasDeployedVehicle = "ttt_maas_trailer";

maasDeployed = false;

ttt_maas_fnc_deploy = {
	params ["_target", "_caller"];
	private ["_maasTrailer1", "_maasTrailer2", "_pos", "_wirePos", "_dir",
	         "_trailer1Pos", "_trailer2Pos"];

	_pos = getPos _target;
	_dir = getDir _target;
	// hide _target under ground
	_target setPos [getPos _target select 0, getPos _target select 1, (getPosATL _target select 2) - 200];

	// calculate three positions for the deployed MAAS
	_trailer1Pos = _pos getPos [20, _dir + 90];
	_trailer2Pos = _pos getPos [20, _dir - 90];
	_wirePos = _pos;

	cutText ["Deploying MAAS trailer 1 ...", "PLAIN DOWN"];
	_maasTrailer1 = maasDeployedVehicle createVehicle _pos;
	_maasTrailer1 setPos _trailer1Pos;
	_maasTrailer1 setDir (getDir _target);
	_maasTrailer1 addAction [
		"Pack MAAS",
		ttt_maas_fnc_pack,
		"",
		6,
		false,
		true,
		"",
		"maasDeployed"
	];
	_maasTrailer1 setVariable ["ttt_maas_parent", _target];
	sleep 1;

	cutText ["Deploying MAAS trailer 2 ...", "PLAIN DOWN"];
	_maasTrailer2 = maasDeployedVehicle createVehicle _trailer2Pos;
	_maasTrailer2 setDir _dir;
	_maasTrailer1 setVariable ["ttt_maas_trailer2", _maasTrailer2];
	sleep 1;

	cutText ["Deploying MAAS wire ...", "PLAIN DOWN"];
	_wire = "ttt_maas_wires" createVehicle _wirePos;
	_wire setDir _dir;
	_maasTrailer1 setVariable ["ttt_maas_wire", _wire];

	maasDeployed = true;
};

ttt_maas_fnc_pack = {
	params ["_target", "_caller"];
	_vehicle = _target getVariable ["ttt_maas_parent", ObjNull];
	cutText ["Collecting wire", "PLAIN DOWN"];
	sleep 1;

	deleteVehicle (_target getVariable ["ttt_maas_wire", ObjNull]);
	cutText ["Packing up trailer", "PLAIN DOWN"];
	sleep 1;

	deleteVehicle (_target getVariable ["ttt_maas_trailer2", ObjNull]);
	cutText ["Packing up MAAS", "PLAIN DOWN"];
	sleep 1;

	deleteVehicle _target;
	sleep 0.1;

	_vehicle setPos [getPos _vehicle select 0, getPos _vehicle select 1, 0];
	_vehicle setDamage 0;

	maasDeployed = false;
};

maasTransport addAction ["Deploy MAAS",
	ttt_maas_fnc_deploy,
	"",
	6,
	false,
	true,
	"",
	"!maasDeployed and vehicle player == player"];
